#include <sys/os16.h>
#include <kernel/devices.h>
#include <sys/types.h>
#include <errno.h>
#include <kernel/memory.h>
#include <kernel/ibm_i86.h>
#include <kernel/proc.h>
#include <string.h>
#include <signal.h>
#include <kernel/k_libc.h>
#include <ctype.h>
#include <kernel/tty.h>
//----------------------------------------------------------------------
ssize_t
dev_io (pid_t pid, dev_t device, int rw, off_t offset,
        void *buffer, size_t size, int *eof)
{
    int dev_major = major (device);
    if (rw != DEV_READ && rw != DEV_WRITE)
      {
        errset (EIO);
        return (-1);
      }
    switch (dev_major)
      {
        case DEV_MEM_MAJOR:
            return (dev_mem (pid, device, rw, offset, buffer, size,
                             eof));
        case DEV_TTY_MAJOR:
            return (dev_tty (pid, device, rw, offset, buffer, size,
                             eof));
        case DEV_CONSOLE_MAJOR:
            return (dev_tty (pid, device, rw, offset, buffer, size,
                             eof));
        case DEV_DSK_MAJOR:
            return (dev_dsk (pid, device, rw, offset, buffer, size,
                             eof));
        case DEV_KMEM_MAJOR:
            return (dev_kmem (pid, device, rw, offset, buffer, size,
                              eof));
        default:
            errset (ENODEV);
            return (-1);
      }
}
