#include <kernel/fs.h>
#include <errno.h>
//----------------------------------------------------------------------
int
sb_zone_status (sb_t *sb, zno_t zone)
{
    int map_element;
    int map_bit;
    int map_mask;
    //
    // Check arguments.
    //
    if (zone == 0 || sb == NULL)
      {
        errset (EINVAL);        // Invalid argument.
        return (-1);
      }
    //
    //  Calculate the map element, the map bit and the map mask.
    //
    map_element = zone / 16;
    map_bit     = zone % 16;
    map_mask    = 1 << map_bit;
    //
    // Check the zone and return.
    //
    if (sb->map_zone[map_element] & map_mask)
      {
        return (1);     // True.
      }
    else
      {
        return (0);     // False.
      }
}
