.global __int16_01
;-----------------------------------------------------------------------
.text
;-----------------------------------------------------------------------
; INT 0x16 - keyboard - check for keystroke
;       AH = 0x01
; Return:
;       ZF set if no keystroke available
;       ZF clear if keystroke available
;           AH = BIOS scan code
;           AL = ASCII character
;
; If a keystroke is present, it is not removed from the keyboard buffer.
;-----------------------------------------------------------------------
.align 2
__int16_01:
    enter #2, #0        ; 1 local variable.
    pushf
    cli
    pusha
    mov   ah, #0x01
    int   #0x16
    jnz   __int16_01_ok
    mov   ax, #0        ; Put zero to AX, if no keystroke is available.
__int16_01_ok:
    mov   -2[bp], ax    ; Save AX.
    popa
    popf
    mov   ax, -2[bp]    ; AX is the function return value.
    leave
    ret
