#include <kernel/ibm_i86.h>
#include <kernel/k_libc.h>
#include <sys/os16.h>
#include <sys/types.h>
#include <stdint.h>
//----------------------------------------------------------------------
void
con_scroll (int console)
{
    static addr_t   address[] = {IBM_I86_VIDEO_ADDRESS};
           addr_t   address_source;
           addr_t   address_destination;
           size_t   size_screen;
           size_t   size_row;
    static uint16_t empty_line[IBM_I86_VIDEO_COLUMNS];
    //
    size_row    = IBM_I86_VIDEO_COLUMNS;
    size_screen = size_row * IBM_I86_VIDEO_ROWS;
    //
    // Scroll up.
    //
    address_source      = address[console];
    address_source     += size_row * 2;
    address_destination = address[console];
    //
    mem_copy (address_source, address_destination,
              (size_t) ((size_screen - size_row) * 2));
    //
    address_destination  = address[console];
    address_destination += ((size_screen - size_row) * 2);
    //
    mem_write (address_destination, &empty_line,
               (size_t) (size_row * 2));
}
