#include <kernel/k_libc.h>
#include <kernel/fs.h>
#include <stdarg.h>
#include <string.h>
#include <errno.h>
//----------------------------------------------------------------------
int
k_open (const char *file, int oflags, ...)
{
    mode_t  mode;
    va_list ap;
    //
    va_start (ap, oflags);
    mode = va_arg (ap, mode_t);
    //
    if (file == NULL || strlen (file) == 0)
      {
        errset (EINVAL);        // Invalid argument.
        return (-1);
      }
    return (fd_open ((pid_t) 0, file, oflags, mode));
}
