#include <kernel/k_libc.h>
#include <errno.h>
//----------------------------------------------------------------------
void
k_perror (const char *s)
{
    //
    // If errno is zero, there is nothing to show.
    //
    if (errno == 0)
      {
        return;
      }
    //
    // Show the string if there is one.
    //
    if (s != NULL && strlen (s) > 0)
      {
        k_printf ("%s: ", s);
      }
    //
    // Show the translated error.
    //
    if (errfn[0] != 0 && errln != 0)
      {
        k_printf ("[%s:%u:%i] %s\n",
                  errfn, errln, errno, strerror (errno));
      }
    else
      {
        k_printf ("[%i] %s\n", errno, strerror (errno));
      }
}
