#ifndef _KERNEL_TTY_H
#define _KERNEL_TTY_H  1

#include <stddef.h>
#include <stdint.h>
#include <sys/types.h>
#include <kernel/ibm_i86.h>

//----------------------------------------------------------------------
#define         TTYS_CONSOLE    IBM_I86_VIDEO_PAGES
#define         TTYS_SERIAL     0
#define         TTYS_TOTAL      (TTYS_CONSOLE + TTYS_SERIAL)
//----------------------------------------------------------------------
#define         TTY_OK          0
#define         TTY_LOST_KEY    1
//----------------------------------------------------------------------
typedef struct {
    dev_t       device;
    pid_t       pgrp;            // Process group.
    int         key;             // Last pressed key.
    int         status;          // 0 = ok, 1 = lost typed character.
} tty_t;
//----------------------------------------------------------------------
extern tty_t tty_table[TTYS_TOTAL];
//----------------------------------------------------------------------
tty_t *tty_reference (dev_t device);
dev_t  tty_console   (dev_t device);
int    tty_read      (dev_t device);
void   tty_write     (dev_t device, int c);
void   tty_init      (void);

#endif
