#include <sys/os16.h>
#include <kernel/tty.h>
//----------------------------------------------------------------------
dev_t
tty_console (dev_t device)
{
    static dev_t device_active = DEV_CONSOLE0;  // First time.
           dev_t device_previous;
    //
    // Check if it required only the current device.
    //
    if (device == 0)
      {
        return (device_active);
      }
    //
    // Fix if the device is not valid.
    //
    if (device > DEV_CONSOLE3 || device < DEV_CONSOLE0)
      {
        device = DEV_CONSOLE0;
      }
    //
    // Update.
    //
    device_previous = device_active;
    device_active   = device;
    //
    // Switch.
    //
    con_select (device_active & 0x00FF);
    //
    // Return previous device value.
    //
    return (device_previous);
}
