#ifndef _INTTYPES_H
#define _INTTYPES_H     1
//----------------------------------------------------------------------

#include <const.h>
#include <restrict.h>
#include <stdint.h>
#include <wchar_t.h>
//----------------------------------------------------------------------
typedef struct {
    intmax_t quot;
    intmax_t rem;
} imaxdiv_t;
//
imaxdiv_t imaxdiv    (intmax_t numer, intmax_t denom);
//----------------------------------------------------------------------
// Output typesetting.
//----------------------------------------------------------------------
#define PRId8           "d"
#define PRId16          "d"
#define PRId32          "ld"
#define PRIdLEAST8      "d"
#define PRIdLEAST16     "d"
#define PRIdLEAST32     "ld"
#define PRIdFAST8       "d"
#define PRIdFAST16      "d"
#define PRIdFAST32      "ld"
#define PRIdMAX         "ld"
#define PRIdPTR         "d"
#define PRIi8           "i"
#define PRIi16          "i"
#define PRIi32          "li"
#define PRIiLEAST8      "i"
#define PRIiLEAST16     "i"
#define PRIiLEAST32     "li"
#define PRIiFAST8       "i"
#define PRIiFAST16      "i"
#define PRIiFAST32      "i"
#define PRIiMAX         "li"
#define PRIiPTR         "i"
#define PRIo8           "o"
#define PRIo16          "o"
#define PRIo32          "lo"
#define PRIoLEAST8      "o"
#define PRIoLEAST16     "o"
#define PRIoLEAST32     "lo"
#define PRIoFAST8       "o"
#define PRIoFAST16      "o"
#define PRIoFAST32      "lo"
#define PRIoMAX         "lo"
#define PRIoPTR         "o"
#define PRIu8           "u"
#define PRIu16          "u"
#define PRIu32          "lu"
#define PRIuLEAST8      "u"
#define PRIuLEAST16     "u"
#define PRIuLEAST32     "lu"
#define PRIuFAST8       "u"
#define PRIuFAST16      "u"
#define PRIuFAST32      "lu"
#define PRIuMAX         "lu"
#define PRIuPTR         "u"
#define PRIx8           "x"
#define PRIx16          "x"
#define PRIx32          "lx"
#define PRIxLEAST8      "x"
#define PRIxLEAST16     "x"
#define PRIxLEAST32     "lx"
#define PRIxFAST8       "x"
#define PRIxFAST16      "x"
#define PRIxFAST32      "lx"
#define PRIxMAX         "lx"
#define PRIxPTR         "x"
#define PRIX8           "X"
#define PRIX16          "X"
#define PRIX32          "lX"
#define PRIXLEAST8      "X"
#define PRIXLEAST16     "X"
#define PRIXLEAST32     "lX"
#define PRIXFAST8       "X"
#define PRIXFAST16      "X"
#define PRIXFAST32      "lX"
#define PRIXMAX         "lX"
#define PRIXPTR         "X"
//----------------------------------------------------------------------
// Input scan and evaluation.
//----------------------------------------------------------------------
#define SCNd8           "hhd"
#define SCNd16          "hd"
#define SCNd32          "d"
#define SCNdLEAST8      "hhd"
#define SCNdLEAST16     "hd"
#define SCNdLEAST32     "d"
#define SCNdFAST8       "hhd"
#define SCNdFAST16      "d"
#define SCNdFAST32      "d"
#define SCNdMAX         "ld"
#define SCNdPTR         "d"
#define SCNi8           "hhi"
#define SCNi16          "hi"
#define SCNi32          "i"
#define SCNiLEAST8      "hhi"
#define SCNiLEAST16     "hi"
#define SCNiLEAST32     "i"
#define SCNiFAST8       "hhi"
#define SCNiFAST16      "i"
#define SCNiFAST32      "i"
#define SCNiMAX         "li"
#define SCNiPTR         "i"
#define SCNo8           "hho"
#define SCNo16          "ho"
#define SCNo32          "o"
#define SCNoLEAST8      "hho"
#define SCNoLEAST16     "ho"
#define SCNoLEAST32     "o"
#define SCNoFAST8       "hho"
#define SCNoFAST16      "o"
#define SCNoFAST32      "o"
#define SCNoMAX         "lo"
#define SCNoPTR         "o"
#define SCNu8           "hhu"
#define SCNu16          "hu"
#define SCNu32          "u"
#define SCNuLEAST8      "hhu"
#define SCNuLEAST16     "hu"
#define SCNuLEAST32     "u"
#define SCNuFAST8       "hhu"
#define SCNuFAST16      "u"
#define SCNuFAST32      "u"
#define SCNuMAX         "lu"
#define SCNuPTR         "u"
#define SCNx8           "hhx"
#define SCNx16          "hx"
#define SCNx32          "x"
#define SCNxLEAST8      "hhx"
#define SCNxLEAST16     "hx"
#define SCNxLEAST32     "x"
#define SCNxFAST8       "hhx"
#define SCNxFAST16      "x"
#define SCNxFAST32      "x"
#define SCNxMAX         "lx"
#define SCNxPTR         "x"
//----------------------------------------------------------------------
intmax_t  strtoimax  (const char *restrict nptr,
                      char **restrict endptr, int base);
uintmax_t strtouimax (const char *restrict nptr,
                      char **restrict endptr, int base);
intmax_t  wcstoimax  (const wchar_t *restrict nptr,
                      wchar_t **restrict endptr, int base);
uintmax_t wcstouimax (const wchar_t *restrict nptr,
                      wchar_t **restrict endptr, int base);
//----------------------------------------------------------------------

#endif
