#ifndef _LIMITS_H
#define _LIMITS_H       1
//----------------------------------------------------------------------
#define CHAR_BIT               (8)
#define SCHAR_MIN          (-0x80)
#define SCHAR_MAX           (0x7F)
#define UCHAR_MAX           (0xFF)
#define CHAR_MIN        SCHAR_MIN
#define CHAR_MAX        SCHAR_MAX
#define MB_LEN_MAX             (1)
#define SHRT_MIN         (-0x8000)
#define SHRT_MAX          (0x7FFF)
#define USHRT_MAX         (0xFFFF)
#define INT_MIN          (-0x8000)
#define INT_MAX           (0x7FFF)
#define UINT_MAX          (0xFFFFU)
#define LONG_MIN     (-0x80000000L)
#define LONG_MAX      (0x7FFFFFFFL)
#define ULONG_MAX     (0xFFFFFFFFUL)
//----------------------------------------------------------------------
#define LLONG_MIN    (-0x80000000L)	// The type `long long int'
#define LLONG_MAX     (0x7FFFFFFFL)     // is not available with
#define ULLONG_MAX    (0xFFFFFFFFUL)    // a K&R C compiler.
//----------------------------------------------------------------------
#define WORD_BIT               16  // POSIX requires at least 32!
#define LONG_BIT               32
#define SSIZE_MAX        LONG_MAX
//----------------------------------------------------------------------
#define ARG_MAX              1024  // Arguments+environment max length.
#define ATEXIT_MAX             32  // Max "at exit" functions.
#define FILESIZEBITS           32  // File size needs integer size...
#define LINK_MAX              254  // Max links per file.
#define NAME_MAX               14  // File name max (Minix 1 fs).
#define OPEN_MAX                8  // Max open files per process.
#define PATH_MAX               64  // Path, including final `\0'.
#define MAX_CANON               1  // Max bytes in canonical tty queue.
#define MAX_INPUT               1  // Max bytes in tty input queue.
//----------------------------------------------------------------------
#define CHLD_MAX     	  INT_MAX  // Not used.
#define HOST_NAME_MAX     INT_MAX  // Not used.
#define LOGIN_NAME_MAX    INT_MAX  // Not used.
#define PAGE_SIZE         INT_MAX  // Not used.
#define RE_DUP_MAX        INT_MAX  // Not used.
#define STREAM_MAX        INT_MAX  // Not used.
#define SYMLOOP_MAX       INT_MAX  // Not used.
#define TTY_NAME_MAX      INT_MAX  // Not used.
#define TZNAME_MAX        INT_MAX  // Not used.
#define PIPE_MAX          INT_MAX  // Not used.
#define SYMLINK_MAX       INT_MAX  // Not used.
//----------------------------------------------------------------------

#endif
