#include <unistd.h>
#include <sys/os16.h>
#include <errno.h>
#include <string.h>
#include <stdio.h>
//----------------------------------------------------------------------
ssize_t
read (int fdn, void *buffer, size_t count)
{
    sysmsg_read_t msg;
    //
    // Reduce size of read if necessary.
    //
    if (count > BUFSIZ)
      {
        count = BUFSIZ;
      }
    //
    // Fill the message.
    //
    msg.fdn   = fdn;
    msg.count = count;
    msg.eof   = 0;
    msg.ret   = 0;
    //
    // Repeat syscall, until something is received or end of file is
    // reached.
    //
    while (1)
      {
        sys (SYS_READ, &msg, (sizeof msg));
        if (msg.ret != 0 || msg.eof)
          {
            break;
          }
      }
    //
    // Before return: be careful with the `msg.buffer' copy, because
    // it cannot be longer than `count', otherwise, some unexpected
    // memory will be overwritten!
    //
    if (msg.ret < 0)
      {
        //
        // No valid read, no change inside the buffer.
        //
        errno = msg.errno;
        return (msg.ret);
      }
    //
    if (msg.ret > count)
      {
        //
        // A strange value was returned. Considering it a read error.
        //
        errset (EIO);                   // I/O error.
        return (-1);
      }
    //
    // A valid read: fill the buffer with `msg.ret' bytes.
    //
    memcpy (buffer, msg.buffer, msg.ret);
    //
    // Return.
    //
    return (msg.ret);
}
