.extern _main
.extern __stdio_stream_setup
.extern __dirent_directory_stream_setup
.extern __atexit_setup
.extern __environment_setup
.global ___mkargv
;-----------------------------------------------------------------------
; Please note that, all segments are already set from the scheduler,
; and there is also data inside the stack, so that the call to `main()'
; function will result as expected.
;
; This is a modified version of `crt0.s' with a smaller stack size.
;-----------------------------------------------------------------------
; The following statement says that the code will start at "startup"
; label.
;-----------------------------------------------------------------------
entry startup
;-----------------------------------------------------------------------
.text
;-----------------------------------------------------------------------
startup:  
    ;
    ; Jump after initial data.
    ;
    jmp startup_code
    ;
filler:
    ;
    ; After four bytes, from the start, there is the
    ; magic number and other data.
    ;
    .space (0x0004 - (filler - startup))
    ;
magic:
    .data4 0x6F733136   ; os16
    .data4 0x6170706C   ; appl
    ;
segoff:                 ;
    .data2 __segoff     ; Data segment offset.
etext:                  ;
    .data2 __etext      ; End of code
edata:                  ; 
    .data2 __edata      ; End of initialized data.
ebss:                   ;
    .data2 __end        ; End of not initialized data.
stack_size:             ;
    .data2 0x2000       ; Requested stack size. Every single application
                        ; might change this value.
    ;
    ; At the next label, the work begins.
    ;
.align 2
startup_code:
    ;
    ; Before the call to the main function, it is necessary to extract
    ; the value to assign to the global variable `environ'. It is
    ; described as `char **environ' and should contain the same address
    ; pointed by `envp'. To get this value, the stack is popped and then
    ; pushed again. Please recall that the stack was prepared from
    ; the process management, at the `exec()' system call.
    ;
    pop ax		; argc
    pop bx		; argv
    pop cx		; envp
    mov _environ, cx	; Variable `environ' comes from <unistd.h>.
    push cx
    push bx
    push ax
    ;
    ; Could it be enough? Of course not! To be able to handle the
    ; environment, it must be copied inside the table
    ; `_environment_table[][]', that is defined inside <stdlib.h>.
    ; To copy the environment it is used the function
    ; `_environment_setup()', passing the `envp' pointer.
    ;
    push cx
    call __environment_setup
    add  sp, #2
    ;
    ; After the environment copy is done, the value for the traditional
    ; variable `environ' is updated, to point to the new array of
    ; pointer. The updated value comes from variable `_environment',
    ; defined inside <stdlib.h>. Then, also the `argv' contained inside
    ; the stack is replaced with the new value.
    ;
    mov  ax, #__environment
    mov  _environ, ax
    ;
    pop ax		; argc
    pop bx		; argv[][]
    pop cx		; envp[][]
    mov cx, #__environment
    push cx
    push bx
    push ax
    ;
    ; Setup standard I/O streams and at-exit table.
    ;
    call __stdio_stream_setup
    call __dirent_directory_stream_setup
    call __atexit_setup
    ;
    ; Call the main function. The arguments are already pushed inside
    ; the stack.
    ;
    call _main
    ;
    ; Save the return value at the symbol `exit_value'.
    ;
    mov  exit_value, ax
    ;
.align 2
halt:
    ;
    push #2		; Size of message.
    push #exit_value	; Pointer to the message.
    push #6             ; SYS_EXIT
    call _sys
    add  sp, #2
    add  sp, #2
    add  sp, #2
    ;
    jmp halt
    ;
;-----------------------------------------------------------------------
.align 2
___mkargv:      ; Symbol `___mkargv' is used by Bcc inside the function
    ret         ; `main()' and must be present for a successful
                ; compilation.
;-----------------------------------------------------------------------
.align 2
.data
;
exit_value:
    .data2 0x0000
;-----------------------------------------------------------------------
.align 2
.bss
